<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);

checkIfNoPhpContentsReceive();

if (
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,['principal'],null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
$academic_id = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if ($academic_id == false) {
    errorreturn("Access denied. Academic session not active.");
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

function getSpecificSalaryParam($conn_rjllearning_specific, $institution_id, $id, $branch_id)
{
    $sql = "SELECT * FROM salary_params WHERE institution_id = ? AND id = ? AND branch_id = ?";
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute([$institution_id, $id, $branch_id]);

    $result = $stmt->fetch(PDO::FETCH_ASSOC);
    if (!$result) {
        errorreturn("No data found for the given ID.");
    }

   $branch_info = $result['branch_id'] == 'all' ? array('branch_id' => 'all', 'name' => ucwords('all')) : 
                           getBranchInfo($conn_rjllearning_specific, $institution_id, $result['branch_id']);
    return [
        'id' => $result['id'],
        'institution_id' => $result['institution_id'],
        'branch_id' => $branch_info,
        'name' => $result['name'],
        'percentage_bool' => $result['percentage_bool'],
        'percent_amount' => $result['percent_amount'],
        'calculate_on' => $result['calculate_on'],
        'type' => $result['type'],
        'applicable_if_amount_lte' => $result['applicable_if_amount_lte'],
        'applicable_if_amount_gte' => $result['applicable_if_amount_gte'],
        'date_created' => $result['date_created'],
        'time_created' => $result['time_created'],
        'status' => $result['status']
    ];
}

if ($postdata['function_type'] == "fetch_specific_salary_param") {
    $id = trim($postdata['id']);

    if (empty($id)) {
        errorreturn("Id are required.");
    }

    $success['data'] = getSpecificSalaryParam($conn_rjllearning_specific, $institution_id, $id, $branch_id);
    successreturn($success);
}
